EvaluateScript("flik_menu.js");

EvaluateScript("movement.js");
EvaluateScript("standard.js");

EvaluateScript("lookups.js");

///////////////////////////////////////////////////////////

function Text(who, message, pos)
{
  var direction = GetPersonDirection(GetCurrentPerson());
  FacePlayer(GetCurrentPerson());
  Talk(who, message, pos);
  SetPersonDirection(GetCurrentPerson(), direction);
}

function __TextChoice__(who, message, pos, choices)
{
  var direction = GetPersonDirection(GetCurrentPerson());
  FacePlayer(GetCurrentPerson());
  var choice = TalkChoice(who, message, pos, choices);
  SetPersonDirection(GetCurrentPerson(), direction);
  return choice;
}

///////////////////////////////////////////////////////////

function KaniWalkToDragonScript()
{
  if (FollowPath(GetCurrentPerson(), "NNNNNNNNNNNEEEEEEENNNNNNNNNNNNNNF") == -1) {
    SetPersonScript(GetCurrentPerson(), SCRIPT_ON_ACTIVATE_TALK, " Text(\"Keni\", \"The dragon's over there...\", \"top\") ");
    SetPersonScript(GetCurrentPerson(), SCRIPT_COMMAND_GENERATOR, "");
    SetPersonDirection(GetCurrentPerson(), "south");
    Text("Kani", "That's as far as I go, the dragon's across the bridge", "top");
    FollowPerson("red_mage", "", 0);
  }
}

function OnTalkToKani() {
  Text("Kani", "A dragon is terrorising the town!", "top");
  if (__TextChoice__("", "What will you do?", "top", ["Get Kani to show you where the dragon is", "Nothing, dragons scare me"]) == 0)
  {
    FollowPerson("red_mage", GetCurrentPerson(), 20);
    SetPersonScript(GetCurrentPerson(), SCRIPT_COMMAND_GENERATOR, "KaniWalkToDragonScript()");
  }
}

///////////////////////////////////////////////////////////

var g_cloned_tiles = [];

function TileEffect() {
  this.min = 0;
  this.max = 255;
  this.delta = 1;
  this.value = 0;
  
  this.update = function() {
    this.value += this.delta;

    if (this.value >= this.max && this.delta > 0) {
      this.value = this.max;
      this.delta *= -1;
    }
   
    if (this.value <= this.min && this.delta < 0) {
      this.value = this.min;
      this.delta *= -1;
    }
  }
}

var g_gamma_effect = new TileEffect();
    g_gamma_effect.value = 0.1;
    g_gamma_effect.delta = 0.1;
    g_gamma_effect.min = 0.1;
    g_gamma_effect.max = 5;

var g_brighten_effect = new TileEffect();
    g_brighten_effect.value = 0;
    g_brighten_effect.delta = 256 / 16;
    g_brighten_effect.min = 0;
    g_brighten_effect.max = 128;

var g_solarize_effect = new TileEffect();
    g_solarize_effect.value = 255;
    g_solarize_effect.delta = -256 / 16;
    g_solarize_effect.min = 0;
    g_solarize_effect.max = 255;

var gTileEffectLookups = new Object();
    gTileEffectLookups.null_lookup     = NullLookup();
    gTileEffectLookups.gamma_lookup    = GammaLookup(g_gamma_effect.value);
    gTileEffectLookups.invert_lookup   = InvertLookup(0, 255);
    gTileEffectLookups.brighten_lookup = BrightenLookup(g_brighten_effect.value);
    gTileEffectLookups.solarize_lookup = SolarizeLookup(g_solarize_effect.value);
    gTileEffectLookups.colors_lookup   = LookupColors(4);
    gTileEffectLookups.threshold_lookup = ThresholdLookup(128);

var g_current_effect_name = "gamma";
var g_current_effect_tile = 0;

GameWindowStyle = LoadWindowStyle("windowstyle.rws");

function RenderScript()
{
  if (g_current_effect_tile >= GetNumTiles())
  {
    g_current_effect_tile = 0;
    
    switch (g_current_effect_name) {
      case "gamma":
        g_gamma_effect.update();      
        gTileEffectLookups.gamma_lookup    = GammaLookup(g_gamma_effect.value);
      break;

      case "brighten":
        g_brighten_effect.update();
        gTileEffectLookups.brighten_lookup = BrightenLookup(g_brighten_effect.value);  
      break;

      case "invert":
      break;

      case "grayify":     
      break;
      
      case "solarize":
        g_solarize_effect.update();
        gTileEffectLookups.solarize_lookup = SolarizeLookup(g_solarize_effect.value);
      break;
      
      case "256colors": gTileEffectLookups.colors_lookup = LookupColors(256); break;
      case "16colors": gTileEffectLookups.colors_lookup  = LookupColors(16); break;
      case "8colors": gTileEffectLookups.colors_lookup   = LookupColors(8); break;
      case "4colors": gTileEffectLookups.colors_lookup   = LookupColors(4); break;
      case "2colors": gTileEffectLookups.colors_lookup   = LookupColors(2); break;
      
      case "threshold":
      break;
    }
  }

  if (g_current_effect_tile < 0 || g_current_effect_tile >= GetNumTiles()) {
    return;
  }

  switch (g_current_effect_name)
  {
    case "gamma":
      var surface = g_cloned_tiles[g_current_effect_tile].clone();
      surface.applyLookup(0, 0, surface.width, surface.height, gTileEffectLookups.gamma_lookup, gTileEffectLookups.gamma_lookup, gTileEffectLookups.gamma_lookup, gTileEffectLookups.null_lookup);
      SetTileSurface(g_current_effect_tile, surface);
      g_current_effect_tile += 1;
    break;  
    
    case "brighten":
      var surface = g_cloned_tiles[g_current_effect_tile].clone();
      surface.applyLookup(0, 0, surface.width, surface.height, gTileEffectLookups.brighten_lookup, gTileEffectLookups.brighten_lookup, gTileEffectLookups.brighten_lookup, gTileEffectLookups.null_lookup);
      SetTileSurface(g_current_effect_tile, surface);    
      g_current_effect_tile += 1;
    break;
    
    case "invert":
      var surface = g_cloned_tiles[g_current_effect_tile].clone();
      surface.applyLookup(0, 0, surface.width, surface.height, gTileEffectLookups.invert_lookup, gTileEffectLookups.invert_lookup, gTileEffectLookups.invert_lookup, gTileEffectLookups.null_lookup);
      SetTileSurface(g_current_effect_tile, surface);    
      g_current_effect_tile += 1;    
    break;
    
    case "solarize":
      var surface = g_cloned_tiles[g_current_effect_tile].clone();
      surface.applyLookup(0, 0, surface.width, surface.height, gTileEffectLookups.solarize_lookup, gTileEffectLookups.solarize_lookup, gTileEffectLookups.solarize_lookup, gTileEffectLookups.null_lookup);
      SetTileSurface(g_current_effect_tile, surface);    
      g_current_effect_tile += 1;        
    break;

    case "grayify":
      var surface = g_cloned_tiles[g_current_effect_tile].clone();
      surface.applyColorFX(0, 0, surface.width, surface.height, CreateColorMatrix(0, 85, 85, 85, 0, 85, 85, 85, 0, 85, 85, 85));
      SetTileSurface(g_current_effect_tile, surface);
      g_current_effect_tile += 1;
    break;
    
    case "256colors":
    case "16colors":
    case "8colors":
    case "4colors":
    case "2colors":
      var surface = g_cloned_tiles[g_current_effect_tile].clone();
      surface.applyLookup(0, 0, surface.width, surface.height, gTileEffectLookups.colors_lookup, gTileEffectLookups.colors_lookup, gTileEffectLookups.colors_lookup, gTileEffectLookups.null_lookup);
      SetTileSurface(g_current_effect_tile, surface);    
      g_current_effect_tile += 1;          
    break;

    case "threshold":
      var surface = g_cloned_tiles[g_current_effect_tile].clone();
      surface.applyColorFX(0, 0, surface.width, surface.height, CreateColorMatrix(0, 85, 85, 85, 0, 85, 85, 85, 0, 85, 85, 85));
      surface.applyLookup(0, 0, surface.width, surface.height, gTileEffectLookups.threshold_lookup, gTileEffectLookups.threshold_lookup, gTileEffectLookups.threshold_lookup, gTileEffectLookups.null_lookup);
      SetTileSurface(g_current_effect_tile, surface);
      g_current_effect_tile += 1;          
    break;
  }
  
  var money_x = GetScreenWidth() - 100;
  var money_y = GetScreenHeight() - 32;
  
  GetGameWindowStyle().drawWindow(money_x, money_y, 72, 16);
  GetSystemFont().drawText(money_x, money_y, "$" + 50);  

  var debug_text = [];
  debug_text.push(g_gamma_effect.value + " " + g_gamma_effect.delta + " " + g_current_effect_tile);
  debug_text.push(g_brighten_effect.value + " " + g_brighten_effect.delta + " " + g_current_effect_tile);
  debug_text.push(g_current_effect_name);

  var debug_width = 0;
  for (var i = 0; i < debug_text.length; i++) {
    debug_width = Math.max(debug_width, GetSystemFont().getStringWidth(debug_text[i]));
  }
  
  var debug_height = (debug_text.length * GetSystemFont().getHeight());
  var debug_x = 16;
  var debug_y = GetScreenHeight() - 16 - debug_height;

  GetGameWindowStyle().drawWindow(debug_x, debug_y, debug_width, debug_height);
  for (var i = 0; i < debug_text.length; i++) {
    GetSystemFont().drawText(debug_x, debug_y + (i * GetSystemFont().getHeight()), debug_text[i]);
  }
}

///////////////////////////////////////////////////////////

function UpdateScript()
{
  if (g_cloned_tiles.length != GetNumTiles()) {
    g_cloned_tiles = [];
    for (var i = 0; i < GetNumTiles(); i++) {
      g_cloned_tiles[i] = GetTileSurface(i);
    }
  }
}

///////////////////////////////////////////////////////////

function GetSpritesetDirectionImageList(spriteset, direction_name)
{
  var direction_index = -1;
  var image_list = [];

  for (var i = 0; i < spriteset.directions.length; i++)
  {
    if (direction_name == spriteset.directions[i].name)
    {
      direction_index = i;
      break;
    }
  }

  if (direction_index != -1) {
    for (var i = 0; i < spriteset.directions[direction_index].frames.length; i++)
    {
      var image_index = spriteset.directions[direction_index].frames[i].index;
      image_list.push(spriteset.images[image_index]);
    }
  }

  return image_list;
}

///////////////////////////////////////////////////////////

function MainMenu()
{
  var menu = DefaultMapMenu(GetScreenWidth() - 124, 64, 124, 16 * 11);
  menu.setArrow(CreateSurface(0, 0, CreateColor(0, 0, 0)));

  menu.addText("Gamma Effect");
  if (g_current_effect_name == "gamma") menu.selection = menu.items.length - 1;

  menu.addText("Brighten Effect");
  if (g_current_effect_name == "brighten") menu.selection = menu.items.length - 1;

  menu.addText("Grayify Effect");
  if (g_current_effect_name == "invert") menu.selection = menu.items.length - 1;

  menu.addText("Invert Effect");
  if (g_current_effect_name == "solarize") menu.selection = menu.items.length - 1;

  menu.addText("Solarize Effect");
  if (g_current_effect_name == "solarize") menu.selection = menu.items.length - 1;

  menu.addText("256colors/channel");
  if (g_current_effect_name == "256colors") menu.selection = menu.items.length - 1;

  menu.addText("16colors/channel");
  if (g_current_effect_name == "16colors") menu.selection = menu.items.length - 1;

  menu.addText("8colors/channel");
  if (g_current_effect_name == "8colors") menu.selection = menu.items.length - 1;

  menu.addText("4colors/channel");
  if (g_current_effect_name == "4colors") menu.selection = menu.items.length - 1;

  menu.addText("2colors/channel");
  if (g_current_effect_name == "2colors") menu.selection = menu.items.length - 1;

  menu.addText("black and white");
  if (g_current_effect_name == "threshold") menu.selection = menu.items.length - 1;

  menu.addText("Quit", function() {
    if (TextChoice("", "Quit.. Are you sure?", "middle", ["Yes", "No"]) == 0) {
      Exit();
    }
    menu.done = true;
  });

  menu.preRender = function() {
    if (IsMapEngineRunning()) RenderMap();
    menu.defaultPreRender();
    
    if (menu.selection == 0) {
      g_current_effect_name = "gamma";
    } else if (menu.selection == 1) {
      g_current_effect_name = "brighten";
    } else if (menu.selection == 2) {
      g_current_effect_name = "grayify";
    } else if (menu.selection == 3) {
      g_current_effect_name = "invert";
    } else if (menu.selection == 4) {
      g_current_effect_name = "solarize";
    } else if (menu.selection == 5) {
      g_current_effect_name = "256colors";
    } else if (menu.selection == 6) {
      g_current_effect_name = "16colors";
    } else if (menu.selection == 7) {
      g_current_effect_name = "8colors";
    } else if (menu.selection == 8) {
      g_current_effect_name = "4colors";
    } else if (menu.selection == 9) {
      g_current_effect_name = "2colors";
    } else if (menu.selection == 10) {
      g_current_effect_name = "threshold";
    }
    
  }
  
  menu.execute();
}

///////////////////////////////////////////////////////////

function game()
{
  SetUpdateScript("UpdateScript()");
  SetRenderScript("RenderScript()");
  
  BindKey(KEY_ESCAPE, "MainMenu()", "");

  CreatePerson("red_mage", "rmani.rss", false);
  AttachInput("red_mage");
  AttachCamera("red_mage");

  MapEngine("test.rmp", 60);
}

///////////////////////////////////////////////////////////

