function GetRandomText()
{
  var me = GetRandomText.arguments;
  return me[Math.floor(Math.random() * me.length)];
}

function IsAnyJoystickButtonPressed(joypad) {
  if (joypad >= 0 && joypad < GetNumJoysticks()) {
    var num_buttons = GetNumJoystickButtons(joypad);
    for (var i = 0; i < num_buttons; i++) {
      if (IsJoystickButtonPressed(joypad, i))
        return true;
    }
  }
  return false;
}

function ClearKeyQueue() {
  while (AreKeysLeft()) GetKey();
}

/**
  Talk("Bob", "Hello", "top");
*/
function Talk(who, text, pos)
{
  var x = 16;
  var width = GetScreenWidth() - 32;
  var y = 16;

  if (who != "")
    text = who + "\n\t" + "\"" + text + "\"";
  else
    text = text;

  var font = GetGameFont();
  var windowstyle = GetGameWindowStyle();
  var height = font.getStringHeight(text, width);

  switch(pos) {
    case ("top") : y = 16; break;
    case ("middle") : y = GetScreenHeight() / 2 - font.getStringHeight(text, width) / 2; break;
    case ("bottom") : y = GetScreenHeight() - font.getStringHeight(text, width) - 48; break;
    default:
      throw ("Talk: Unknown pos type");
  }

  var time = GetTime() + 75;
  ClearKeyQueue();

  while (time > GetTime() || !AreKeysLeft()) {
    if (IsMapEngineRunning())
      RenderMap();

    windowstyle.drawWindow(x, y, width, height);
    font.drawTextBox(x, y, width, height, 0, text);
    FlipScreen();
  }

  ClearKeyQueue();
}

/**
  @param choices An array of strings that make up the choices
*/
function TalkChoice(who, text, pos, choices)
{
  var x = 16;
  var width = GetScreenWidth() - 32;
  var y = 16;

  if (who != "")
    text = who + "\n\t" + "" + text + "";
  else
    text = text;

  var font = GetGameFont();
  var windowstyle = GetGameWindowStyle();
  var height = font.getStringHeight(text, width);

  switch(pos) {
    case ("top") : y = 16; break;
    case ("middle") : y = GetScreenHeight() / 2 - font.getStringHeight(text, width) / 2; break;
    //case ("bottom") : y = GetScreenHeight() - font.getStringHeight(text, width) - 48; break;
    default:
      throw ("TalkChoice: Unknown pos type");
  }

  var menu = DefaultMapMenu(16, y + height + 16, GetScreenWidth() - 32, Math.min(choices.length * 16, Math.max(64, choices.length * 16)));
  
  menu.preRender = function() {
    if (IsMapEngineRunning())
      RenderMap();
  
    windowstyle.drawWindow(x, y, width, height);
    font.drawTextBox(x, y, width, height, 0, text);

    windowstyle.drawWindow(menu.x, menu.y, menu.width, menu.height);
  }

  for (var i = 0; i < choices.length; i++) {
    menu.addText(choices[i]);
  }

  menu.execute();
  ClearKeyQueue();

  if (menu.escaped)
    return -1;

  return menu.selection;
}

/**
  @param choices An array of strings that make up the choices
*/
function TextChoice(who, text, pos, choices)
{
  var x = 16;
  var width = GetScreenWidth() - 32;
  var y = 16;

  if (who != "")
    text = who + "\n\t" + "" + text + "";
  else
    text = text;

  var font = GetGameFont();
  var windowstyle = GetGameWindowStyle();
  var height = font.getStringHeight(text, width);

  switch(pos) {
    case ("top") : y = 16; break;
    case ("middle") : y = GetScreenHeight() / 2 - font.getStringHeight(text, width) / 2; break;
    //case ("bottom") : y = GetScreenHeight() - font.getStringHeight(text, width) - 48; break;
    default:
      throw ("TalkChoice: Unknown pos type");
  }
  
  var menu = DefaultMenu(16, y + height + 16, GetScreenWidth() - 32, Math.min(choices.length * 16, Math.max(64, choices.length * 16)));
  menu.background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
  
  menu.preRender = function() {
    menu.background.blit(0, 0);
 
    windowstyle.drawWindow(x, y, width, height);
    font.drawTextBox(x, y, width, height, 0, text);

    windowstyle.drawWindow(menu.x, menu.y, menu.width, menu.height);
  }

  for (var i = 0; i < choices.length; i++) {
    menu.addText(choices[i]);
  }

  menu.execute();
  ClearKeyQueue();

  if (menu.escaped)
    return -1;

  return menu.selection;
}
